#! /usr/bin/perl -w -I/usr/lib/cril-perl-support/lib
# demo-gui.pl user-login.pl -- Manual script for SMB login
# AUTHOR
#    Marc SCHAEFER <schaefer@alphanet.ch>
# LICENSE
#    (C) 2005 by Marc SCHAEFER, licensed under the terms of the
#     GNU General Public License as published by the Free Software
#     Foundation; either version 2 or later (at your option).
# DESCRIPTION
#    This quite simple script implements a simple login.
# NOTES
# BUGS
#    - Missing documentation.
# TODO
# BASED-ON
#    CEIJ's user_login.pl

use strict;

use simple_gtk;
use piped_commands;

my $result = 0; # SUCCESS
my $error_reason = "unknown";

# Don't change the numbers.
my %fields = (1 => { label => 'Utilisateur (login)',
                     type  => 'textfield'
                   },
              2 => { label => 'Mot de passe',
                     type => 'textfield',
                     invisible => undef
		   });

my %buttons = (1 => { 'label' => 'Effacer',
                      'delta' => '2',
                      'action' => \&ClearAction
                    },
               2 => { 'label' => 'Se connecter',
                      'delta' => '2',
                      'action' => \&LoginAction
                    });

if (gtk_do(\$error_reason,
           'Connexion aux donnes Microsoft Windows',
           'Entrez les informations de connexion: ',
           \&gtk_quit_action,
           \%buttons,
           \%fields)) {
}
else {
   $result = 1;
   $error_reason = 'gtk_do(): ' . $error_reason;
}

if ($result) {
   print STDERR $0, ": something failed.\n";
   exit $result;
}

sub ClearAction {
   return gtk_clear_action(\%fields);
}

sub LoginAction {
   my $login = $fields{1}->{ref}->get_text();
   my $password = $fields{2}->{ref}->get_text();

   my $error_reason = 'unknown';

   if (exec_piped_command('/usr/local/bin/suid-mounter.pl login ' . $login,
                          [ $password ],
                          \$error_reason)) {
      exit 0;
   }
   else {
      print "failed: ", $error_reason, "\n";
      gtk_clear_action(\%fields);

      gtk_post_requester("Erreur", "Vrifiez vos informations", [ 'OK' ]);
   }
}
