#! /usr/bin/perl -w

use strict;

# Prototypes (et forward declarations)
sub affichage_habitant($);
sub affichage_pays($);

# Il n'y a pas  proprement parler de structures ou RECORDs en Perl
# (on les mule p.ex. avec des hashes).
my %marc = ('nom' => 'Marc SCHAEFER',
            'naissance' => '1972-04-06');

my %guillaume = ('nom' => 'Guillaume TELL',
                 'naissance' => '1254-03-12');

# Les habitants sont une liste de rfrences sur des hashes.
my @habitants = (\%marc, \%guillaume);

my %pays = ('nom' => 'Suisse',
            'superficie' => '41294000',
            'drapeau' => 'drapeau_suisse.png',
            'habitants' => \@habitants);
# NOTES
#    - habitants => [ \%marc, \%guillaume ]);
#      aurait t quivalent.
#    - On peut aussi construire un hash_ref directement ainsi:
#         my $hash_ref = { 'nom' => 'Marc SCHAEFER, 'blabla' => 'truc };

# Affichons ces donnes
#print affichage_habitant(\%marc), "\n";
print affichage_pays(\%pays), "\n";

exit 0;

sub affichage_habitant($) {
   my ($habitant_hash_ref) = @_;

   # perldoc -f map
   # variable de contrle implicite, dangereux
   return join("\n",
               map("   " . $_ . " -> " . $habitant_hash_ref->{$_},
                   keys %{$habitant_hash_ref}))
          . "\n";
}

sub affichage_pays($) {
   my ($pays_hash_ref) = @_;

   my $str = "";

   foreach my $k (keys %{$pays_hash_ref}) {
      # comparaison de chane avec 'eq', pas '=='.
      if ($k eq 'habitants') {
         $str .= 'HABITANTS' . "\n"
                 . join("\n", map(affichage_habitant($_),
                                  @{$pays_hash_ref->{$k}}));
      }
      else {
         # on peut aussi crire: %{$pays_hash_ref}{$k}
         $str .= $k . ': ' . $pays_hash_ref->{$k};
      }

      $str .= "\n";
   }

   return $str;
}


