#! /usr/bin/perl -w

use strict;

# Dfinition d'un tableau de hchage: (cl => valeur)
my %hash = ('gazon' => 'vert',
            'limace' => 'brune',
            'ciel' => 'bleu');

# Obtenir les valeurs d'un hash: c'est un tableau (@array)
my @couleurs = values %hash;
print "Les couleurs: ", join(', ', @couleurs), ".\n";

# Consultez `perldoc -f join'
print "Les choses: ", join(', ', keys %hash), "\n";

print "\n";

# Parcours tri d'un hash (consultez `perldoc -f sort')
# (sans le tri le parcours est considr alatoire)
foreach my $chose (sort keys %hash) {
   print $chose, " -> ", $hash{$chose}, "\n";
}

print "\n";

# Autre variante non trie plus efficace
# (le parcours est considr alatoire)
while (my ($key, $value) = each(%hash)) {
   print $key, " -> ", $value, "\n";
}

exit 0;

