#! /usr/bin/perl -w

use strict;
use Storable;

# Prototypes (et forward declarations)
sub affichage_habitant($);
sub affichage_pays($);

my $file_name = $0;
$file_name =~ s/.pl/.BINARY-HASH/;

my %pays = ('nom' => 'Suisse',
            'superficie' => '41294000',
            'drapeau' => 'drapeau_suisse.png',
            'habitants' => [ { 'nom' => 'Marc SCHAEFER',
                               'naissance' => '1972-04-06'
                             },
                             { 'nom' => 'Guillaume TELL',
                               'naissance' => '1254-03-12'
                             }
                           ]);
# Affichons ces donnes
print affichage_pays(\%pays), "\n";

# Stockons ces donnes
store(\%pays, $file_name) or die("store()");

# Dtruisons le hash
undef %pays;

# Affichons (rien)
print affichage_pays(\%pays), "\n";

# Rechargeons les donnes
my $new_pays_ref = retrieve($file_name);
if (!defined($new_pays_ref)) {
   die("retrieve()");
}

# Affichons ces donnes
print affichage_pays($new_pays_ref), "\n";

# ou encore
%pays = %{$new_pays_ref};
print affichage_pays(\%pays), "\n";

# Effaons le fichiers (comment!)
# unlink $file_name or die("unlink()");

exit 0;

# Copi de ../hash/*tree.pl ... nous ferons un exercice pour
# implmenter cela  un seul endroit (packages/modules)!
sub affichage_habitant($) {
   my ($habitant_hash_ref) = @_;

   # perldoc -f map
   # variable de contrle implicite, dangereux
   return join("\n",
               map("   " . $_ . " -> " . $habitant_hash_ref->{$_},
                   keys %{$habitant_hash_ref}))
          . "\n";
}

sub affichage_pays($) {
   my ($pays_hash_ref) = @_;

   my $str = "";

   foreach my $k (keys %{$pays_hash_ref}) {
      # comparaison de chane avec 'eq', pas '=='.
      if ($k eq 'habitants') {
         $str .= 'HABITANTS' . "\n"
                 . join("\n", map(affichage_habitant($_),
                                  @{$pays_hash_ref->{$k}}));
      }
      else {
         # on peut aussi crire: %{$pays_hash_ref}{$k}
         $str .= $k . ': ' . $pays_hash_ref->{$k};
      }

      $str .= "\n";
   }

   return $str;
}


