#! /usr/bin/perl -w

# Lancez-moi plusieurs fois. Je vais stocker le timestamp de lancement
# dans la base et une valeur alatoire, effacer les timestamps trop
# anciens et afficher le contenu.

use strict;
use DB_File;

# DB_File est une interface  DB/DBM/NBM, un simple fichier index
# sous la forme de ($key, $value). Un hash simple peut tre
# gr de cette manire, via le `tie' (perldoc -f tie).

# Si la valeur  stocker est plus complexe qu'une seule valeur,
# il faut compacter les donnes dans le champ value ($v).
# Par exemple:
#    $hash{$timestamp} = freeze \%pays;
#    %pays = %{thaw($hash{$timestamp})}
# Inutile de dire qu'en gnral, un tel hash est plutt  grer
# sous forme de SQL (DBI), p.ex. SQL Lite ou PostgreSQL.

my %hash;
my $filename = 'demo-tie';
if (tie(%hash, 'DB_File', $filename)) {
   my $timestamp = time();
   my $random_value = int(rand(10));

   $hash{$timestamp} = $random_value;

   if (!exists($hash{$timestamp})) {
      die("ne peut se produire");
   }

   while (my ($k, $v) = each(%hash)) {
      if ($k < ($timestamp - 5)) {
         delete $hash{$k};
      }
   }

   while (my ($k, $v) = each(%hash)) {
      print $k, " -> ", $v, "\n";
   }

   if (!untie(%hash)) {
      die;
      # error handling ...
   }
}
else {
   die;
   # error handling ...
}

